/*
      Grade Manager 1.0

      Copyleft by kim jin hong

      This software manages grade of student. (generic purpose)
      The version 1.0 is the first of GM.  And I'll not
      upgrade GM anymore.

      Ability:
	* Cool interface.
	* Deal four hundred students. (adjustable size)
	* Many convenient functions..
	* Safety (prevent error)
	* etc...


      - About 14 warnings will be occured. Ignore them.
*/

#include <stdio.h>
#include <dir.h>
#include <string.h>
#include <fcntl.h>
#include <io.h>
#include "c:\project\code\pulldown\pulldown.h"
#include "menu.h"

#define MAXFILENUM 	256
#define MAXSTUDENT	400
#define MAXLINE	 	15
#define MAXOUTLINE	21

#define F15B1		31
#define F0B7		112
#define F15B3		63
#define F15B4		79
#define F15B2		47
#define F15B7           127
#define F15B0		15
#define F3B1		19
#define F1B3		49

#define _BKSPACE	0xe08
#define _SPACE          0x3920
#define _TAB            0xf09

typedef struct
{
  char name[13];
  char attr;
} NAMELIST;

typedef struct
{
  int id;
  char class[2];
  char name[15];
  int gkor;
  int gmat;
  int geng;
  float avr;
  int total;
  int ptotal;
  int rank;
} STUDENT;

typedef struct
{
  int num;
  int ptotal;
} CLASS;

NAMELIST nl[MAXFILENUM];
STUDENT sl[MAXSTUDENT];
CLASS cl[MAXSTUDENT];

char selfile[13];
int sl_idx=0;
int cl_idx=0;
char hver='0';
char lver='0';
char name[13];
int needrerank=FALSE;

void initialize(void);
int filelist(char *, int, char *);
void drawbox(int, int, int, int, int, int);
void savescr(int *, int, int, int, int);
void restorescr(int *);
void messagebox(char **, int, int, char *, int, int **, int);
void exitproc(void);
void sfile(void);
int openfile(void);
void savefile(void);
void paintdesktop(void);
void clearfield(void);
void menu_nuset(int);
void newfile(void);
int input(char *, int, int, int, int, int);
void closeall(void);
void editrecord(STUDENT *);
int checkfield(STUDENT *, int);
void insert(void);
void delete(int);
int list(int, int, int, int, int);
void drawrecord(STUDENT *, int, int);
void drawallrecord(int);
void makemeter(int, int, int, int, int);
void generalinfo(void);
void quicksort(int, int, int);
void swap2student(STUDENT *a, STUDENT *b);
void makerankall(void);
int makerankclass(void);
void sameptotalcase(int);
int existclass(char, int *);
void drawfilename(void);
void savefileas(void);
void finddata(int);

#pragma exit exitproc

void main()
{
       int inkey, getkey;
       int opened=FALSE;

       initialize();

       while (TRUE)
       {
	 if (_multiproc) (*_multiprocess)();

	 if (!kbhit()) continue;
	 inkey=bioskey(0);

	 if (inkey/256==0x44) getkey=selectmenu(0);
	 else getkey=selectmenu(inkey);

	 if (!_menuselected) continue;

	 switch (_menuidx)
	 {
	   case 1:  /* file menu */
	     switch (_baridx)
	     {
		case 0:
			newfile();
			break;
		case 1:
			if (filelist(name,FALSE,"Open File"))
			  if (openfile() == NULL)
			  {
			    list(TRUE, FALSE, FALSE, TRUE, 0);
			    opened=TRUE;
			  }
			break;
		case 2:
			savefile();
			break;
		case 3:
			savefileas();
			list(TRUE, FALSE, FALSE, TRUE, 0);
			break;
		case 4:
			closeall();
			opened=FALSE;
			break;
		case 5:
			filelist(name,TRUE,"Change Dir");    /* change dir */
			break;
		case 6: /* dos shell */
			textattr(7);
			clrscr();
			cursor(TRUE);
			system("command.com");
			cursor(FALSE);
			drawtitle();
			paintdesktop();
			if (opened) list(TRUE, FALSE, FALSE, TRUE, 0);
			break;
		case 7:                   	    /* quit */
			exit(0);
			break;
	     }
	     break;

	   case 2:  /* edit menu */
		switch(_baridx)
		{
		   case 0:     /* edit menu */
			list(FALSE, FALSE, FALSE, FALSE, 0);
			needrerank=TRUE;
			drawfilename();
			break;

		   case 1:     /* insert menu */
			insert();
			list(TRUE, FALSE, FALSE, FALSE, 0);
			break;
		   case 2:     /* delete menu */
			delete(FALSE);
			list(TRUE, FALSE, FALSE, TRUE, 0);
			break;
		   case 3:    /* delete all */
			delete(TRUE);
			list(TRUE, FALSE, FALSE, TRUE, 0);
			break;
		}
		break;

	   case 3:  /* search menu */
		switch(_baridx)
		{
		  case 0:
		  case 1:
		     finddata(_baridx);
		     break;
		}
		break;

	   case 4:  /* result menu */
		switch(_baridx)
		{
		   case 0:  /* view list */
		       list(FALSE, TRUE, FALSE, FALSE, 0);
		       break;

		   case 1:  /* refresh */
		       list(TRUE, FALSE, FALSE, TRUE, 0);
		       break;
		}
		break;

	   case 5:   /* management */
	     switch (_baridx)
	     {
	       case 0:  /* general information */
		   generalinfo();
		   break;
	       case 1:  /* make rank all */
		   makerankall();
		   needrerank=FALSE;
		   drawfilename();
		   list(TRUE, FALSE, FALSE, TRUE, 0);
		   break;
	       case 2:  /* make rank class */
		   if (makerankclass() == NULL)
		   {
		     list(FALSE, TRUE, TRUE, TRUE, 0);
		     needrerank=FALSE;
		     drawfilename();
		   }
		   list(TRUE, FALSE, FALSE, TRUE, 0);
		   break;
	     }
	     break;

	   case 6:   /* help menu */
	     switch (_baridx)
	     {
	       case 0: /* help */
		   messagebox(helpmsg, F15B7, 0, " Help ", TRUE, NULL, 1);
		   break;

	       case 1: /* about */
		   messagebox(message, F15B7, 0, " About ", TRUE, NULL, 1);
		   break;
	     }
	     break;

	   case 7:   /* sort menu */
	     switch (_baridx)
	     {
		case 0:  /* id */
		case 1:  /* class */
		case 2: quicksort(0, sl_idx-1, _baridx); break; /* name */
		case 4: quicksort(0, sl_idx-1, 8); break; /* rank */
	     }
	     list(TRUE, FALSE, FALSE, FALSE, 0);
	     break;

	   case 8:  /* sort grade... */
	     switch (_baridx)
	     {
		case 0:  /* gkor */
		case 1:  /* gmat */
		case 2:  /* geng */
		case 3:  /* total */
		case 4: quicksort(0, sl_idx-1, _baridx+3); break; /* avr */
	     }
	     list(TRUE, FALSE, FALSE, FALSE, 0);
	     break;
	 }
       }
}

void exitproc()
{
  textattr(7);
  clrscr();
  cursor(TRUE);
  printf("This stuff is for GNU freaks...\n");
  exit(0);
}

void paintdesktop()
{
  int x,y;

  for(y=2; y<=25; y++)
    for (x=1; x<=80; x++) p16c(x,y,'', 113);
}

void initialize()
{
/* 0 */ settitle(title);
/* 1 */ setframe(file,0,0);
/* 2 */	setframe(edit,0,1);
/* 3 */	setframe(search,0,2);
/* 4 */	setframe(result,0,3);
/* 5 */ setframe(manage,0,4);
/* 6 */	setframe(help,0,5);
/* 7 */ setframe(sort,5,3);
/* 8 */ setframe(sortgrade, 7,3);

       menu_nuset(TRUE);

       addsck(1,6,0x2004);  /* define CTRL+D */
       addsck(1,7,0x2d00);  /* define ALT+X */
       addsck(1,1,0x3d00);  /* define F3 */
       addsck(1,2,0x3c00);  /* ... F2 */
       addsck(1,4,0x3e00);  /* .. F4 */

       cursor(FALSE);
       drawtitle();
       paintdesktop();

       fprint(" neuron corea", 66, 1, F0B7, FALSE, TRUE);

       messagebox(message, F15B7, 0, " About ", TRUE, NULL, 1);
}

void clearfield()
{
  int t;

  sl_idx=0;
  hver='0';
  lver='0';
  ginfo[0][24]=hver;
  ginfo[0][25]='.';
  ginfo[0][26]=lver;
  memcpy(&ginfo[2][24], "     ", 3);

  for (t=0; t<MAXSTUDENT; t++)
  {
    sl[t].id=0;
    sl[t].class[0]=NULL;
    sl[t].name[0]=NULL;
    sl[t].gkor=0;
    sl[t].gmat=0;
    sl[t].geng=0;
    sl[t].total=0;
    sl[t].ptotal=0;
    sl[t].avr=0.0;
    sl[t].rank=0;
  }
}

void menu_nuset(int TF)
{
       setnouse(0,1,TF);  /* Edit menu */
       setnouse(0,2,TF);  /* Search */
       setnouse(0,3,TF);  /* Result */
       setnouse(1,2,TF);  /* Save/File */
       setnouse(1,3,TF);  /* SaveAs/File */
       setnouse(1,4,TF);  /* Close/File */
       setnouse(0,4,TF);  /* Management */
       drawtitle();    /* redraw the title menu */
       fprint(" neuron corea", 66, 1, F0B7, FALSE, TRUE);
}

void newfile()
{
  clearfield();
  menu_nuset(FALSE);

  strcpy(name, "UNTITLED.DAT");
  sfile();
}

int openfile()
{
  FILE *handle;
  int t;
  char header[5];

  if ((handle=fopen(name,"rb")) == NULL)
  {
    messagebox(error1, F15B4, 15, " System ", TRUE, NULL, 0);
    return -1;
  }

  clearfield();

  fread(header, 5, 1, handle);
  header[3]=NULL;   /* make string */
  if (strcmp(header, "GMD") != 0)
  {
    messagebox(errmsg4, F15B4, 15, " System ", TRUE, NULL, 0);
    return -1;
  }

  hver += (header[4] >> 4);
  lver += (header[4] & 0x0f);

  fread(&sl_idx, 2, 1, handle);
  fread(&sl[0], sizeof(STUDENT), sl_idx, handle);

  sfile();

  menu_nuset(FALSE);

  fclose(handle);

  return 0;
}

void drawfilename()
{
  char buf[20];
  int col;

  strcpy(selfile, name);
  strcpy(buf, " ");
  strcat(buf, selfile);
  strcat(buf, " ");
  if (needrerank) col=F15B4;
  else col=F15B1;
  fprint(buf, 64, 2, col, TRUE, TRUE);
}

void sfile()
{
  drawbox(2,1,25,80, F15B1, 1);
  drawfilename();
  makemeter(20, sl_idx, 0, 79, 3);
}

void drawlistbar(int num, int x, int y, int bool)
{
  char strbuf[15];

  if (nl[num].attr == FA_DIREC) {
    strcpy(strbuf, "[");
    strcat(strbuf, nl[num].name);
    strcat(strbuf, "]");
  } else strcpy(strbuf, nl[num].name);

  if (bool) fprint(strbuf, x, y, 15, TRUE, TRUE);
  else fprint(strbuf, x, y, F0B7, TRUE, TRUE);
}

void drawlist(int bbase, int x, int y, int cnt)
{
  int t;

  for (t=0; t<MAXLINE; t++) {
    if (t>cnt-1) break;
    fprint("            ", x+2, y+1+t, F0B7, TRUE, TRUE);
    drawlistbar(bbase+t, x+2, y+1+t, 0);
  }
}

int filelist(char *name, int attr, char *title)
{
   struct ffblk ffblk;
   int done, cnt=0;
   int x,y, *scr;
   int ink, bidx=0, bbase=0;
   int esc, runonce=1;
   char strbuf[15];

   while (runonce) {
     runonce=0;
     esc=1;

     done = findfirst("*.*",&ffblk,FA_ARCH|FA_DIREC);
     while (!done) {
       if (cnt >= MAXFILENUM) break;

       if (attr == 1)
	 if (ffblk.ff_attrib != FA_DIREC) {
	   done = findnext(&ffblk);
	   continue;
	 }

       if (strcmp(ffblk.ff_name,".") == 0) {
	 done = findnext(&ffblk);
	 continue;
       }

       strcpy(nl[cnt].name, ffblk.ff_name);
       nl[cnt].attr=ffblk.ff_attrib;
       cnt++;
       done = findnext(&ffblk);
     }

     x=10; y=5;
     savescr(&scr, x-1, y-1, 18, MAXLINE+3);
     drawbox(y, x, y+MAXLINE+1, x+15, F0B7, 0);
     fprint(title, x+2, y, F0B7, TRUE, FALSE);
     drawlist(0, x, y, cnt);
     drawlistbar(0,x+2,y+1,1);

     while (esc) {
       while (bioskey(1) == 0);

       ink=bioskey(0);

       drawlistbar(bbase+bidx,x+2,y+1+bidx,0);

       switch(ink)
       {
	 case _ESC:
		restorescr(&scr);
		return 0;

	 case _DOWN:
		if ((bidx < MAXLINE-1) && (bidx < cnt-1)) bidx++;
		else
		  if (bbase+bidx < cnt-1) bbase++;
		break;
	 case _UP:
		if (bidx > 0) bidx--;
		else
		  if (bbase > 0) bbase--;
		break;
	 case _ENTER:
		if (nl[bbase+bidx].attr == FA_DIREC) {
		  chdir(nl[bbase+bidx].name);
		  done=0;
		  runonce=1;
		  cnt=0;
		  bidx=0;
		  bbase=0;
		  esc=0;
		} else {
		  strcpy(name, nl[bbase+bidx].name);
		  restorescr(&scr);
		  return 1;
		}
       }

       drawlist(bbase, x, y, cnt);
       drawlistbar(bbase+bidx,x+2,y+1+bidx,1);
     }

     restorescr(&scr);
   }
}

void drawbox(int t, int l, int b, int r, int col, int font)
{
  char *bf;
  char tmp,i,k;

  bf="ڿٳɻȼ";

  if (font==0) k=0; else k=6;

  for (tmp=t+1; tmp<=b-1; tmp++)
    for (i=l+2; i<=r-2; i++) p16c(i,tmp,' ',col);

  for (tmp=t; tmp<=b; tmp++) {
    p16c(l,tmp,' ',col);
    p16c(r,tmp,' ',col);
  }

  for (tmp=l+2; tmp<=r-2; tmp++) {
    p16c(tmp,t,bf[5+k],col);
    p16c(tmp,b,bf[5+k],col);
  }

  for (tmp=t+1; tmp<=b-1; tmp++) {
    p16c(l+1,tmp,bf[4+k],col);
    p16c(r-1,tmp,bf[4+k],col);
  }

  p16c(l+1,t,bf[k],col);
  p16c(r-1,t,bf[1+k],col);
  p16c(l+1,b,bf[2+k],col);
  p16c(r-1,b,bf[3+k],col);

  if (_mshadowing) shadowing(t,l,b,r);
}

void messagebox(char **arr, int tcol, int fcol, char *title, int wait, int **ss, int fn)
{
  int *scr;
  int x, y, len=0, num=0;
  int t, addy;

  while(arr[num] != NULL)
  {
    if (len < strlen(arr[num])) len=strlen(arr[num]);
    num++;
  }

  x=(80-len)/2;
  y=(25-num)/2;

  addy=(wait) ? (3):(1);

  if (wait) savescr(&scr, x-4, y-1, len+8, num+5);
  else savescr(ss, x-4, y-1, len+8, num+3);

  drawbox(y, x-3, y+num+addy, x+len+2, tcol, fn);
  fprint(title, x+len/2-strlen(title)/2, y, tcol, TRUE, FALSE);

  for (t=0; t<num; t++)
    fprint(arr[t], x, y+1+t, (tcol&0xf0)+fcol, FALSE, FALSE);

  if (wait)
  {
    fprint("   OK   ", x+len/2-4, y+num+1, 32, TRUE, FALSE);
    fprint("", x+len/2-3+7, y+num+1, tcol&0xf0, TRUE, FALSE);
    fprint("", x+len/2-3, y+num+2, tcol&0xf0, TRUE, FALSE);

    while (bioskey(0) != _ENTER);

    p16c(x+len/2-4, y+num+1,' ', tcol&0xf0);
    fprint("   OK   ", x+len/2-3, y+num+1, 32, TRUE, FALSE);
    fprint("        ", x+len/2-3, y+num+2, tcol&0xf0, TRUE, FALSE);
    delay(100);

    restorescr(&scr);
  }
}

int input(char *out, int x, int y, int len, int focus, int wait)
{
  char buf[50];
  int t, idx=0;
  int key, col;

  gotoxy(x,y);
  if (wait) cursor(TRUE);

  if (focus) col=F15B0; else col=F15B2;

  if (out == NULL)
    for (t=0; t<=len; t++) p16c(x+t,y,' ',col);
  else
  {
    for (t=0; t<=len; t++) p16c(x+t,y,' ',col);
    fprint(out, x, y, col, TRUE, TRUE);
    strcpy(buf, out);
    idx=strlen(out);
    gotoxy(x+idx, y);
  }

  if (!wait) return 0;

  while (1)
  {
    while(bioskey(1) == 0);

    key=bioskey(0);

    switch(key)
    {
      case _BKSPACE:
	   if (idx > 0) idx--;
	   buf[idx]=' ';
	   p16c(x+idx,y,' ', col);
	   gotoxy(x+idx, y);
	   break;
      case _ESC:
	   cursor(FALSE);
	   return _ESC;
      case _TAB:
      case _UP:
      case _DOWN:
      case _ENTER:
	   buf[idx]=NULL;
	   strcpy(out, buf);
	   cursor(FALSE);
	   return key;
      default:
	   key &= 0xff;
	   if (key >= 32 && key <= 126)
	     if (idx < len) {
	       buf[idx]=(char)key;
	       p16c(x+idx,y,buf[idx], col);
	       idx++;
	       gotoxy(x+idx,y);
	     }
	   break;
    }
  }
}

void editrecord(STUDENT *out)
{
  char buf0[6], buf1[16], buf2[3], buf3[4], buf4[4], buf5[4];
  char buf[10];
  int *scr;
  int midx=0, ret;
  STUDENT std={0,NULL,NULL,0,0,0,0};

  if (out->name[0] == NULL)
  {
    memset(buf0, 0, 6);
    memset(buf1, 0, 16);
    memset(buf2, 0, 3);
    memset(buf3, 0, 4);
    memset(buf4, 0, 4);
    memset(buf5, 0, 4);
  }
  else
  {
    std.id=out->id;
    strcpy(std.class, out->class);
    strcpy(std.name, out->name);
    std.gkor=out->gkor;
    std.gmat=out->gmat;
    std.geng=out->geng;
    std.rank=out->rank;
    itoa(out->id, buf, 10); memcpy(buf0, buf, 6);
    memcpy(buf1, out->name, 16);
    memcpy(buf2, out->class, 3);
    itoa(out->gkor, buf, 10); memcpy(buf3, buf, 4);
    itoa(out->gmat, buf, 10); memcpy(buf4, buf, 4);
    itoa(out->geng, buf, 10); memcpy(buf5, buf, 4);
  }

  messagebox(insertboard, F0B7, 15, " Input Information ", FALSE, &scr, 0);
  input(buf0, 40, 8, 5, TRUE, FALSE);
  input(buf1, 40, 10, 15, FALSE, FALSE);
  input(buf2, 40, 12, 1, FALSE, FALSE);
  input(buf3, 40, 14, 3, FALSE, FALSE);
  input(buf4, 40, 16, 3, FALSE, FALSE);
  input(buf5, 40, 18, 3, FALSE, FALSE);

  while (1)
  {
     switch(midx)
     {
       case 0:
	     ret=input(buf0, 40, 8, 5, TRUE, TRUE);
	     input(buf0, 40, 8, 5, FALSE, FALSE);
	     std.id=atoi(buf0);
	     break;
       case 1:
	     ret=input(buf1, 40, 10, 15, TRUE, TRUE);
	     input(buf1, 40, 10, 15, FALSE, FALSE);
	     strcpy(std.name,buf1);
	     break;
       case 2:
	     ret=input(buf2, 40, 12, 1, TRUE, TRUE);
	     input(buf2, 40, 12, 1, FALSE, FALSE);
	     strcpy(std.class,buf2);
	     break;
       case 3:
	     ret=input(buf3, 40, 14, 3, TRUE, TRUE);
	     input(buf3, 40, 14, 3, FALSE, FALSE);
	     std.gkor=atoi(buf3);
	     break;
       case 4:
	     ret=input(buf4, 40, 16, 3, TRUE, TRUE);
	     input(buf4, 40, 16, 3, FALSE, FALSE);
	     std.gmat=atoi(buf4);
	     break;
       case 5:
	     ret=input(buf5, 40, 18, 3, TRUE, TRUE);
	     input(buf5, 40, 18, 3, FALSE, FALSE);
	     std.geng=atoi(buf5);
	     break;
     }

     switch (ret)
     {
       case _DOWN:
	 if (midx < 6) midx++;
	 else midx=0;
	 break;

       case _UP:
	 if (midx > 0) midx--;
	 else midx=6;
	 break;

       case _ESC:
	 restorescr(&scr);
	 return;

       case _ENTER:
	 memcpy(out, &std, sizeof(STUDENT));
	 restorescr(&scr);
	 return;

       case _TAB:
	 if (midx < 6) midx++;
	 else midx=0;
	 break;
     }
  }
}

int checkfield(STUDENT *std, int isedit)
{
  int t, bool=TRUE;

  if (!isedit)
    for (t=0; t<sl_idx; t++)
      if (sl[t].id == std->id)
      {
	messagebox(errmsg1, F0B7, 15, " Error ", TRUE, NULL, 0);
	bool=FALSE;
      }

  if ((std->class[0] == NULL))
  {
      messagebox(errmsg2, F0B7, 15, " Error ", TRUE, NULL, 0);
      bool=FALSE;
  }

  if (std->name[0] == NULL)
  {
      messagebox(errmsg3, F0B7, 15, " Error ", TRUE, NULL, 0);
      bool=FALSE;
  }

  return bool;
}

void insert()
{
  STUDENT std;

  memcpy(&std, &sl[sl_idx], sizeof(STUDENT));
  editrecord(&std);

  if (checkfield(&std, FALSE))
  {
    std.total=std.gkor+std.geng+std.gmat;
    std.ptotal=std.gkor+std.geng*2+std.gmat*3;
    std.avr=(float)std.total/3;
    memcpy(&sl[sl_idx], &std, sizeof(STUDENT));
    if (sl_idx < MAXSTUDENT) sl_idx++;
    needrerank=TRUE;
    drawfilename();
  }
}

void delete(int all)
{
  int num;
  int *scr, k, t;

  if (sl_idx == 0) return;

  if (!all)
  {
    messagebox(delsel, F15B2, 15, " System ", FALSE, &scr, 0);
    while(bioskey(1) == 0); bioskey(0);
    restorescr(&scr);
    num=list(FALSE, TRUE, FALSE, FALSE, 0);
    if (num >= 0)
      messagebox(delmsg, F15B4, 15, " WARNNING ", FALSE, &scr, 0);
  }
  else
    messagebox(delmsg2, F15B4, 15, " WARNNING!! ", FALSE, &scr, 0);

  while(bioskey(1) == 0);
  k=bioskey(0);

  if (k == _SPACE)
  {
    if (!all)
    {
      for (t=num; t<sl_idx-1; t++)
	memcpy(&sl[t], &sl[t+1], sizeof(STUDENT));
      sl_idx--;
    }
    else clearfield();
    needrerank=TRUE;
    drawfilename();
  }

  restorescr(&scr);
}

void closeall()
{
  clearfield();
  paintdesktop();
  menu_nuset(TRUE);
}

void drawrecord(STUDENT *sll, int y, int rev)
{
  char buf[10];
  int col, t;

  col=(rev) ? F15B0: F15B1;

  for (t=4; t<=77; t++) p16c(t,y,' ', col);
  itoa(sll->id, buf, 10);

  fprint(buf, 4, y, col, TRUE, TRUE);
  fprint(sll->class, 10, y, col, TRUE, TRUE);
  fprint(sll->name, 17, y, col, TRUE, TRUE);
  itoa(sll->gkor, buf, 10);
  fprint(buf, 33, y, col, TRUE, TRUE);
  itoa(sll->gmat, buf, 10);
  fprint(buf, 41, y, col, TRUE, TRUE);
  itoa(sll->geng, buf, 10);
  fprint(buf, 47, y, col, TRUE, TRUE);

  itoa(sll->total, buf, 10);
  fprint(buf, 57, y, col, TRUE, TRUE);

  textattr(col);
  gotoxy(64, y); cprintf("%.1f", sll->avr);
  textattr(7);

  itoa(sll->rank, buf, 10);
  fprint(buf, 71, y, col, TRUE, TRUE);
}

void drawallrecord(int base)
{
  int t=0;

  while ((base+t <= sl_idx-1) && (t < MAXOUTLINE))
  {
    drawrecord(&sl[base+t], t+4, FALSE);
    t++;
  }
}

void drawallcl(int base)
{
  int t=0;

  while ((base+t <= cl_idx-1) && (t < MAXOUTLINE))
  {
    drawrecord(&sl[cl[base+t].num], t+4, FALSE);
    t++;
  }
}

int list(int viewonly, int selectonly, int viewcl, int clr, int sy)
{
  int ink;
  int idx=0;
  int bbase=0;
  STUDENT std;

  if (clr) sfile();

  if (!viewcl && sl_idx == 0) return -1;
  if (viewcl && cl_idx == 0) return -1;

  fprint("ID    CLASS  NAME            KOREAN  MATH  ENGLISH   TOTAL  AVR    RANK", 4, 3, F15B1, TRUE, TRUE);

  idx=sy % (MAXOUTLINE-1);
  bbase=sy / (MAXOUTLINE-1);
  if (bbase > 0)
  {
    bbase=idx;
    idx=MAXOUTLINE-1;
  }

  if (viewcl) drawallcl(bbase);
  else drawallrecord(bbase);

  if (viewonly) return -1;

  if (viewcl) drawrecord(&sl[cl[bbase+idx].num], idx+4, TRUE);
  else drawrecord(&sl[bbase+idx], idx+4, TRUE);

  makemeter(20, sl_idx, bbase+idx, 79, 3);

  while (1)
  {
       while (bioskey(1) == 0);

       ink=bioskey(0);

       if (viewcl) drawrecord(&sl[cl[bbase+idx].num], idx+4, FALSE);
       else drawrecord(&sl[bbase+idx], idx+4, FALSE);

       switch(ink)
       {
	 case _ESC:
		return -1;

	 case _DOWN:
		if (viewcl)
		{
		  if ((idx < MAXOUTLINE-1) && (idx < cl_idx-1)) idx++;
		  else
		    if (bbase+idx < cl_idx-1)
		    {
		      bbase++;
		      drawallcl(bbase);
		    }
		}
		else
		{
		  if ((idx < MAXOUTLINE-1) && (idx < sl_idx-1)) idx++;
		  else
		    if (bbase+idx < sl_idx-1)
		    {
		      bbase++;
		      drawallrecord(bbase);
		    }
		}
		break;

	 case _UP:
		if (idx > 0) idx--;
		else
		  if (bbase > 0)
		  {
		    bbase--;
		    if (viewcl) drawallcl(bbase);
		    else drawallrecord(bbase);
		  }
		break;

	 case _ENTER:
		if (selectonly) return (bbase+idx);

		memcpy(&std,&sl[bbase+idx],sizeof(STUDENT));
		editrecord(&std);
		if (checkfield(&std, TRUE))
		{
		  std.total=std.gkor+std.geng+std.gmat;
		  std.ptotal=std.gkor+std.geng*2+std.gmat*3;
		  std.avr=(float)std.total/3;
		  memcpy(&sl[bbase+idx], &std, sizeof(STUDENT));
		}
		break;
       }

       if (viewcl)
       {
	 drawrecord(&sl[cl[bbase+idx].num], idx+4, TRUE);
	 makemeter(20, cl_idx, bbase+idx, 79, 3);
       }
       else
       {
	 drawrecord(&sl[bbase+idx], idx+4, TRUE);
	 makemeter(20, sl_idx, bbase+idx, 79, 3);
       }
  }
}

void savefile()
{
  FILE *handle;
  int t;
  char header[5]={'G','M','D',0x1A, 16};

  if ((handle=fopen(name,"wb")) == NULL)
  {
    messagebox(error1, F15B4, 15, " System ", TRUE, NULL, 0);
    return;
  }

  fwrite(header, 5, 1, handle);   	/* header */
  fwrite(&sl_idx, 2, 1, handle);
  fwrite(&sl[0], sizeof(STUDENT), sl_idx, handle);

  fclose(handle);

  messagebox(saved, F15B3, 15, " System ", TRUE, NULL, 0);
}

void makemeter(int len, int total, int index, int x, int y)
{
  int t;

  for (t=0; t<len; t++) p16c(x, y+t+1, '', F3B1);

  if (total==0) total=1;
  if (index==0) index=1;

  p16c(x,y,30, F1B3);
  p16c(x,y+len+1,31,F1B3);
  p16c(x,y+1+len*index/total ,'',F1B3);
}

void generalinfo()
{
  char buf[10];

  ginfo[0][24]=hver;
  ginfo[0][25]='.';
  ginfo[0][26]=lver;

  itoa(sl_idx, buf, 10);

  memcpy(&ginfo[2][24], buf, 3);

  messagebox(ginfo, F15B7, 15, " Information ", TRUE, NULL, 0);
}

void sameptotalcase(int clcase)
{
  int t;

  if (clcase)
  {
    for (t=1; t<sl_idx; t++)
      if (sl[t].ptotal == sl[t-1].ptotal)
	sl[t].rank=sl[t-1].rank;
  }
  else
  {
    for (t=1; t<cl_idx; t++)
      if (sl[cl[t].num].ptotal == sl[cl[t-1].num].ptotal)
	sl[cl[t].num].rank=sl[cl[t-1].num].rank;
  }
}

void makerankall()
{
  int t;

  quicksort(0, sl_idx-1, 9);   /* 9 == sort by ptotal */
  for (t=0; t<sl_idx; t++) sl[t].rank=t+1;
  sameptotalcase(TRUE);
}

void swap2student(STUDENT *a, STUDENT *b)
{
  STUDENT tmp;

  memcpy(&tmp, a, sizeof(STUDENT));
  memcpy(a, b, sizeof(STUDENT));
  memcpy(b, &tmp, sizeof(STUDENT));
}

void quicksort(int left, int right, int cas)
{
  int l=left, r=right+1, tmp;
  char buf[15], ctmp;
  float ftmp;

  if (l < r) {
	switch (cas)
	{
	  case 0: tmp=sl[left].id; break;
	  case 1: ctmp=sl[left].class[0]; break;
	  case 2: strcpy(buf, &sl[left].name); break;
	  case 3: tmp=sl[left].gkor; break;
	  case 4: tmp=sl[left].gmat; break;
	  case 5: tmp=sl[left].geng; break;
	  case 6: tmp=sl[left].total; break;
	  case 7: ftmp=sl[left].avr; break;
	  case 8: tmp=sl[left].rank; break;
	  case 9: tmp=sl[left].ptotal; break;  /* making rank */
	  case 10: tmp=sl[cl[left].num].ptotal; break;
	}

	while (1) {
	  switch (cas)
	  {
	    case 0:
		do l++; while (sl[l].id < tmp);
		do r--; while (sl[r].id > tmp);
		break;
	    case 1:
		do l++; while (sl[l].class[0] < ctmp);
		do r--; while (sl[r].class[0] > ctmp);
		break;
	    case 2:
		do l++; while (strcmp(sl[l].name,buf) < 0);
		do r--; while (strcmp(sl[r].name,buf) > 0);
		break;
	    case 3:
		do l++; while (sl[l].gkor > tmp);
		do r--; while (sl[r].gkor < tmp);
		break;
	    case 4:
		do l++; while (sl[l].gmat > tmp);
		do r--; while (sl[r].gmat < tmp);
		break;
	    case 5:
		do l++; while (sl[l].geng > tmp);
		do r--; while (sl[r].geng < tmp);
		break;
	    case 6:
		do l++; while (sl[l].total > tmp);
		do r--; while (sl[r].total < tmp);
		break;
	    case 7:
		do l++; while (sl[l].avr > ftmp);
		do r--; while (sl[r].avr < ftmp);
		break;
	    case 8:
		do l++; while (sl[l].rank < tmp);
		do r--; while (sl[r].rank > tmp);
		break;
	    case 9:
		do l++; while (sl[l].ptotal > tmp);
		do r--; while (sl[r].ptotal < tmp);
		break;
	    case 10:
		do l++; while (sl[cl[l].num].ptotal > tmp);
		do r--; while (sl[cl[r].num].ptotal < tmp);
		break;
	  }

	  if (cas == 10)
	  {
	    if (l < r) swap2student(&sl[cl[l].num], &sl[cl[r].num]);
	    else break;
	  }
	  else
	    if (l < r) swap2student(&sl[l], &sl[r]);
	    else break;
	}

	if (cas == 10)
	  swap2student(&sl[cl[left].num], &sl[cl[r].num]);
	else
	  swap2student(&sl[left], &sl[r]);

	quicksort(left, r-1, cas);
	quicksort(r+1, right, cas);
  }
}

void savescr(int *s, int sx, int sy, int wid, int dep)
{
  int t, *wbuf;

  if ((wbuf = (int *)malloc(sx*sy*2+8)) == NULL) {
     printf("Not enough memory to allocate buffer\n");
     exit(1);
  }

  *s=(unsigned)wbuf;

  *wbuf=sx; wbuf++;
  *wbuf=sy; wbuf++;
  *wbuf=wid; wbuf++;
  *wbuf=dep; wbuf++;

  for (t=0;t<dep;t++) {
    movedata(DISPSEG, sx*2+(sy+t)*160, _DS, (unsigned)wbuf, wid*2);
    wbuf+=wid;
  }
}

void restorescr(int *s)
{
  int t, *wbuf;
  int sx, sy, wid, dep;

  wbuf=(int *)*s;

  sx=*wbuf; wbuf++;
  sy=*wbuf; wbuf++;
  wid=*wbuf; wbuf++;
  dep=*wbuf; wbuf++;

  for (t=0;t<dep;t++) {
    movedata(_DS,(unsigned)wbuf,DISPSEG,sx*2+(sy+t)*160,wid*2);
    wbuf+=wid;
  }

  free((unsigned *)(*s));
}

int existclass(char c, int *cnt)
{
  int t;

  *cnt=0;
  for (t=0; t<sl_idx; t++)
    if (sl[t].class[0] == c)
    {
      cl[*cnt].num=t;
      cl[*cnt].ptotal=sl[t].ptotal;
      (*cnt)++;
    }

  return *cnt;
}

int makerankclass()
{
  int t, *scr;
  char buf[3]={0,0,0};

  messagebox(rankclass, F0B7, 15, " Requirement ", FALSE, &scr, 0);
  input(buf, 39, 13, 1, TRUE, TRUE);

  if (!existclass(buf[0], &cl_idx))
  {
    messagebox(rankclasserr, F15B4, 15, " System ", TRUE, NULL, 0);
    restorescr(&scr);
    return -1;
  }

  quicksort(0, cl_idx-1, 10);   /* 10 == sort by ptotal in specified class */

  for (t=0; t<cl_idx; t++) sl[cl[t].num].rank=t+1;
  sameptotalcase(FALSE);

  restorescr(&scr);
  return 0;
}

void savefileas()
{
  int t, *scr;
  char buf[14]={0,0,0,0,0,0,0,0,0,0,0,0,0,0};

  messagebox(saveas, F0B7, 15, " Requirement ", FALSE, &scr, 0);
  if (input(buf, 33, 14, 13, TRUE, TRUE) == _ENTER)
    if (buf[0] != NULL)
    {
      strcpy(name, buf);
      savefile();
    }

  restorescr(&scr);
}

void finddata(int cas)
{
  int t, *scr;
  char bufid[6]={0,0,0,0,0,0};
  char bufname[16]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
  int id;

  if (cas == 0)
  {
    messagebox(searchid, F0B7, 15, " Requirement ", FALSE, &scr, 0);

    if (input(bufid, 39, 14, 5, TRUE, TRUE) == _ENTER)
    {
      restorescr(&scr);
      if (bufid[0] != NULL)
      {
	id=atoi(bufid);
	for (t=0; t<sl_idx; t++)
	  if (sl[t].id == id)
	    list(FALSE, TRUE, FALSE, FALSE, t);
      }
    } else restorescr(&scr);
  }
  else
    if (cas == 1)
    {
      messagebox(searchname, F0B7, 15, " Requirement ", FALSE, &scr, 0);

      if (input(bufname, 32, 14, 15, TRUE, TRUE) == _ENTER)
      {
	restorescr(&scr);
	if (bufname[0] != NULL)
	{
	  for (t=0; t<sl_idx; t++)
	    if (strstr(sl[t].name, bufname) != NULL)
	      list(FALSE, TRUE, FALSE, FALSE, t);
	}
      } else restorescr(&scr);
    }
}
