/* Computer Engineering Sophomore #964524 Kim jin hong */


/*
	       Pulldown Menu Processor (on trial) 1997
	     -------------------------------------------

	       Code by KIM JIN HONG (neuron)

	       CHARACTERISTICS

	       + Menu can be extended (almost infinited) while the memory
		 is allowed. But, to realize this perfectly, some additional
		 codes are required
	       + Convenient usage (cool really!)
		 Easy implementation. Easy to register, etc...
	       + Support popup style
	       + Support additional processing (with no parameter)
	       + Shortcut key system like BC 3.0 IDE
	       + Submenu previewing
	       + Total ability of changing shapes of menu freely

		 But...   ^^;

	       - Pretty big volume of code! So the program cannot
		 supply fully empty code-segment. This problem has
		 not been solved since because I have no sufficient
		 time to improve the code.. This program is an ASSIGNMENT
		 from DATA STRUCTURE.

	       NOTE:
		 Please ignore warning messages after compile.
		 The warnings cannot be corrected on this time.
		 The codes are should be exist as they are now.
		 But, the compiler recognizes they are so warnable.

		 And...

		 I will support mouse system!
 
		 ;)
*/

#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <dos.h>
#include <ctype.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <bios.h>

#define TRUE  		1
#define FALSE 		0
#define MAXMENU 	99
#define MAXLINE 	22
#define MAXSHORTCUTBUF  150
#define DISPSEG    	0xb800       /* video display segment */
#define DISPFSEG 	0xb8000000   /* video display far segment */
#define NONE		0xff

#define _LEFT	0x4b00
#define _RIGHT	0x4d00
#define _UP	0x4800
#define _DOWN	0x5000
#define _ENTER	0x1c0d
#define _ESC	0x11b

typedef unsigned char byte;


/*** GLOBAL VARIABLES ***/

struct frametype {
  char **str;
  byte x,y,idx;
  byte num,prev,mx;
  byte sub[MAXLINE];

  struct {
    byte nouse : 1;
    byte linec : 7;     /* line coordinate X or Y */
  } infol[MAXLINE];

  struct {
    byte havesub : 1;   /* 1bit used as BOOLEAN type in 16bit */
    byte menucn  : 3;   /* menu cut number */
			/* other 4bits are reserved */
  } infom;

} frm[MAXMENU];

struct {
  int key;                   /* key scan code */
  byte fn,ln;                /* fn=frame number, ln=line number */
} _sckbuf[MAXSHORTCUTBUF];   /* shortcut key buffer */

byte _sckbufidx     =0;          /* shortcut key buffer index */
byte _frameidx      =1;
byte _menuidx       =0;          /* (uv) menu index */
byte _baridx        =0;          /* (uv) menu bar index */
				 /* (uv) means user variable */

/* following two consts are used in scan2char */
byte alpha_data[26]={                                           /* scan codes */
	      30,48,46,32,18,33,34,35,23,36,37,38,50,49,24,25,  /* 'A' to 'P' */
	      16,19,31,20,22,47,17,45,21,44};                   /* 'Q' to 'Z' */
byte number_data[10]={11,2,3,4,5,6,7,8,9,10};                   /* '0' to '9' */



/*** MENU SHAPES ***/
char _mtitle_x      =2;          /* (uv) menu title x coordinate */
char _mtitle_y      =1;          /* (uv) menu title y coordinate */
char _menubkcolor   =7;          /* (uv) menu background color */
char _menufgcolor   =0;          /* (uv) menu foreground color */
char _menulinefont  =0;          /* (uv) menu box line font. should be 0 or 1 */
char _mshadowing    =TRUE;       /* (uv) menu shadowing */
char _barcolor      =2;          /* (uv) menu bar color */
char _schlcolor     =4;          /* (uv) shortcut highlight color */
char _schltrigger   ='~';        /* (uv) shortcut highlight trigger */
char _menucuttrigger='|';        /* (uv) menu cutting trigger */
byte _nousebarcolor =0;          /* (uv) non-usable menu bar color */
char _nousefgcolor  =8;          /* (uv) non-usable menu foreground color */
char _submenusign   =16;         /* (uv) submenu inform-sign ascii code */
char _submsigndist  =3;          /* (uv) submenu inform-sign distance(margin) */
char _submenudist   =4;          /* (uv) submenu distance(margin) from the parent */
float _prevreactime =0.7;        /* (uv) submenu previewing-reaction time(sec) */

byte _nouseattr     =NULL;       /* initialized by FIRSTSET */
byte _menuattr      =NULL;       /* initialized by FIRSTSET */
char _timereact     =NULL;       /* initialized by FIRSTSET */
char _callonce      =FALSE;      /* used by PULLDOWN */
char _previewing    =FALSE;      /* (uv) */
char _multiproc     =TRUE;       /* (uv) */
char _POPUP         =FALSE;      /* used by PULLDOWN */
char _menuselected  =FALSE;      /* (uv) */
char *_popupsave;                /* used by PULLDOWN */
void (*_multiprocess)(void);     /* (uv) function pointer */

/*** main functions associated with Menu Processor ***/
void FIRSTSET(void);             /* automatically run once before run main() */
#pragma startup FIRSTSET 64      /* to make above FIRSTSET() run before main() */
				 /* 64 is the highest priority in user's one */
void initializer(void);          /* general initialization */
void settitle(char **str);
void setframe(char **str, byte prvn, byte ln);
void drawbar(byte i, char bool);
void drawbartop(char bool);
void drawtitle(void);
int selectmenu(int ink);
int subprocess(byte i);
void nullfunction(void);         /* do nothing */
void setnouse(byte i, char ln, char bool);
char getnouse(byte i, char ln);
char checknouse(byte i);
char *getstr(byte fn,byte ln);
void setstr(byte fn, byte ln, char *str, byte idx, char bool);
void drawcutline(char t, char l, char r, byte bc, char font);
void addsck(byte fn, byte ln, int kval);
void resetsck(void);
void resetmenu(void);

/*** miscellaneous associated with Menu Processor ***/
byte getlinenum(char **str);
byte findsck(int ink);
byte findmenuhlk(char idx, int inkey); /* find menu highlight key */
byte scan2char(byte scancode);
byte maxlen(char **str, byte num);
void shadowedcolor(unsigned in, unsigned *out);
void shadowing(char t, char l, char b, char r);
char getmenucn(byte fn); /* get menu cutting number */
int quitstate(byte midx, byte bidx, int rc);
byte getsubmenuidx(byte i);
byte gettopsck(int inkey);
byte getsubmenusck(byte midx, int inkey);
void previewsubmenu(byte i);

/*** MISCELLANEOUS ***/
char altpushed(void);
void fprint(char *str, char x, char y, byte col, char bool);
unsigned long lroundoff(float x);
void p16c(char x, char y, byte ch, byte cc);
void box(byte i, byte bc, char font);
void cursor(int nf);
byte posc(char *str, char c);
byte poss(char *str1, char *str2);
void save_screen(byte i, int *buf);
void restore_screen(byte i, int *buf);
byte charcounter(char *str, byte len, char c);

void multitest(void);      /* a testing procedure */

void main()
{
       char *title[] = {
	 "~File",
	 "~Edit",
	 "~Search",
	 "~Run",
	 "~Compile",
	 "~Debug",
	 "~Project",
	 "~Options",
	 "~Window",
	 "~Help",
	 "~UV", NULL
       };

       char *file[]={
	 "~New",
	 "~Open...          F3",
	 "~Save...          F2",
	 "S~ave as...",
	 "Save a~ll",
	 "|~Change dir...",
	 "~Print",
	 "~DOS Shell    Ctrl+D",
	 "|~Quit          Alt+X", NULL
       };

       char *edit[]={
	 "~Undo           Alt+BkSp",
	 "~Redo     Shift+Alt+BkSp",
	 "|~Cut           Shift+Del",
	 "C~opy           Ctrl+Ins",
	 "~Paste         Shift+Ins",
	 "C~lear          Ctrl+Del",
	 "Copy ~example",
	 "|~Show clipboard", NULL
       };

       char *run[]={
	 "~Run            Ctrl+F9",
	 "~Program reset  Ctrl+F2",
	 "~Go to cursor        F4",
	 "~Trace into          F7",
	 "~Step over           F8",
	 "~Arguments...", NULL
       };

       char *run_trace[] = {
	 "Trace level ~1",
	 "Trace level ~2",
	 "Trace level ~3",
	 "Trace level ~4", NULL
       };

       char *search[]={
	 "~Find...",
	 "~Replace...",
	 "~Search again      Ctrl+L",
	 "|~Go to line number",
	 "~Previous error    Alt+F7",
	 "~Next error        Alt+F8",
	 "~Locate function", NULL
       };

       char *compile[]={
	 "~Compile           Alt+F9",
	 "~Make                  F9",
	 "~Link",
	 "~Build all",
	 "|~Information...",
	 "~Remove messages", NULL
       };

       char *debug[]={
	 "~Inspect...          Alt+F4",
	 "~Evaluate/modify    Ctrl+F4",
	 "~Call stack         Ctrl+F3",
	 "~Watches",
	 "~Toggle breakpoint  Ctrl+F8",
	 "~Breakpoints", NULL
       };

       char *project[]={
	 "~Open project...",
	 "~Close project",
	 "|~Add item",
	 "~Delete item",
	 "~Local options",
	 "~Include files", NULL
       };

       char *option[]={
	 "~Application",
	 "~Compiler",
	 "~Transfer",
	 "~Make...",
	 "~Linker",
	 "L~ibrarian",
	 "De~bugger",
	 "~Directories",
	 "|~Environment",
	 "|~Save...", NULL
       };

       char *debug_watch[]={
	 "~Add watch",
	 "~Delete watch",
	 "~Edit watch",
	 "~Remove all watches...", NULL
       };

       char *option_compiler[]={
	 "~Code generation",
	 "~Advanced code generation",
	 "~Entry/Exit Code",
	 "C++ opt~ions",
	 "~Optimizations",
	 "~Source",
	 "~Messages",
	 "~Names", NULL
       };

       char *option_linker[]={
	 "~Settings...",
	 "~Libraries...", NULL
       };

       char *option_environment[]={
	 "~Preferences...",
	 "~Editor...",
	 "~Mouse...",
	 "~Desktop...",
	 "~Startup...",
	 "~Colors...", NULL
       };

       char *run_trace_3[]={
	 "~INTRODUCTION",
	 "~Pulldown Menu Processor",
	 "(c) 1996 KIM, JIN HONG (~neuron)",
	 "~UNLIMITED VERSION", NULL
       };

       char *window[]={
	 "~Size/Move     Ctrl+F5",
	 "~Zoom               F5",
	 "~Tile",
	 "~Cascade",
	 "~Next               F6",
	 "~Close          Alt+F3",
	 "C~lose all",
	 "|~Message",
	 "~Output",
	 "~Watch",
	 "~User screen    Alt+F5",
	 "~Register",
	 "~Project",
	 "Proj~ect notes",
	 "|List ~all...     Alt+0", NULL
       };

       char *help[]={
	 "~Contents",
	 "~Index            Shift+F1",
	 "~Topic search      Ctrl+F1",
	 "~Previous topic     Alt+F1",
	 "~Help on help",
	 "|~About...", NULL
       };

       char *run_trace_3_3[]={
	 "11",
	 "22",
	 "33",
	 "44",
	 "55",
	 "66", NULL
       };

       char *run_trace_3_3_6[]={
	 "1",
	 "2",
	 "3",
	 "4",
	 "5",
	 "6",
	 "7", NULL
       };

       char *option_compiler_message[]={
	 "~Display...",
	 "~Potability...",
	 "~Ansi violations...",
	 "~C++ warnings...",
	 "~Frequent errors...",
	 "~Less frequent errors...", NULL
       };

       int inkey, getkey;

/* 0 */ settitle(title);
/* 1 */ setframe(file,0,0);
/* 2 */ setframe(run,0,3);
/* 3 */ setframe(run_trace,2,3);
/* 4 */ setframe(edit,0,1);
/* 5 */ setframe(search,0,2);
/* 6 */ setframe(compile,0,4);
/* 7 */ setframe(debug,0,5);
/* 8 */ setframe(project,0,6);
/* 9 */ setframe(option,0,7);
/*10 */ setframe(debug_watch,7,3);
/*11 */ setframe(option_compiler,9,1);
/*12 */ setframe(option_linker,9,4);
/*13 */ setframe(option_environment,9,8);
/*14 */ setframe(run_trace_3,3,2);
/*15 */ setframe(window,0,8);
/*16 */ setframe(help,0,9);
/*17 */ setframe(run_trace_3_3,14,3);
/*18 */ setframe(run_trace_3_3_6,17,5);
/*19 */ setframe(option_compiler_message,11,6);

       setnouse(2,1,TRUE);
       setnouse(4,1,TRUE);
       setnouse(4,2,TRUE);
       setnouse(4,3,TRUE);
       setnouse(4,5,TRUE);
       setnouse(4,6,TRUE);
       setnouse(5,4,TRUE);
       setnouse(5,6,TRUE);
       setnouse(7,2,TRUE);
       setnouse(8,1,TRUE);
       setnouse(8,2,TRUE);
       setnouse(8,3,TRUE);
       setnouse(8,4,TRUE);
       setnouse(8,5,TRUE);
       setnouse(15,12,TRUE);
       setnouse(15,13,TRUE);
       /* setnouse(0,2,TRUE); */

       addsck(1,8,0x2d00);  /* define ALT+X */
       addsck(1,7,0x2004);  /* define CTRL+D */
       _multiprocess=multitest;

       cursor(FALSE);

       /* if you want popup style, set _POPUP=TRUE and eliminate drawtitle()
	  from begining of the program.
	  In this program, below drawtitie() is that */

       drawtitle();

       while (TRUE) {
	 if (_multiproc) (*_multiprocess)();
	      if (!kbhit()) continue;
	      inkey=bioskey(0);

	      if (inkey/256==0x44) getkey=selectmenu(0);
	      else getkey=selectmenu(inkey);

	      gotoxy(1,25);
	      cprintf("Menu Idx:%2d Bar Idx:%2d Getkey:%4X",_menuidx,_baridx,getkey);

	 if (!_menuselected) continue;

	      switch (_menuidx) {
		     case 1:
			    switch (_baridx) {
				case 8:
					cursor(TRUE);
					exit(0);
					break;
				case 7:
					sound(3000);
					delay(500);
					nosound();
					break;
			    }
			    break;
	      }
       }
}

byte getlinenum(char **str)
{
  byte cnt=0;

  while (**(str+cnt) != NULL) cnt++;

  return cnt;
}

void settitle(char **str)
{
  byte t;
  char cnt;

  frm[0].str=str;
  frm[0].x=_mtitle_x;
  frm[0].y=_mtitle_y;
  frm[0].idx=0;
  frm[0].num=getlinenum(str);
  frm[0].prev=NONE;
  frm[0].mx=0;
  frm[0].infom.havesub=FALSE;
  frm[0].infom.menucn=0;  /* useless var. For only frame[0] of title */

  cnt=frm[0].x;
  for (t=0;t<MAXLINE;t++) {
    frm[0].infol[t].nouse=FALSE;
    frm[0].sub[t]=NONE;
    frm[0].infol[t].linec=cnt;
    cnt+=strlen(*(frm[0].str+t))+2;
    if (posc(*(frm[0].str+t),_schltrigger)>0) cnt--;
  }
}

void setframe(char **str, byte prvn, byte ln)
{
  byte t, num=getlinenum(str);
  char cnt=0;

  frm[_frameidx].str=str;

  for (t=0;t<MAXLINE;t++) {
    frm[_frameidx].sub[t]=NONE;
    frm[_frameidx].infol[t].nouse=FALSE;
    if (**(frm[_frameidx].str+t)==_menucuttrigger) cnt++;
    frm[_frameidx].infol[t].linec=cnt;
    cnt++;
  }

  frm[_frameidx].idx=0;
  frm[_frameidx].num=num;
  frm[_frameidx].prev=prvn;
  frm[prvn].sub[ln]=_frameidx;
  frm[_frameidx].mx=maxlen(str,num);
  frm[_frameidx].infom.havesub=FALSE;
  frm[_frameidx].infom.menucn=getmenucn(_frameidx);

  if (prvn==0) {
    frm[_frameidx].x=frm[0].infol[ln].linec+2;
    frm[_frameidx].y=frm[0].y+2;
  } else {
     frm[_frameidx].x=frm[prvn].x+_submenudist;
     frm[_frameidx].y=frm[prvn].y+ln+2;

     if (!frm[prvn].infom.havesub) {
       frm[prvn].mx+=_submsigndist;
       frm[prvn].infom.havesub=TRUE;
     }
  }

  _frameidx++;
}

void drawbar(byte i, char bool)
{
   byte t,col;
   unsigned offset;

   if (bool) {
     if (checknouse(i)) col=_nousebarcolor;
     else col=_barcolor;
   } else col=_menubkcolor;

   for (t=0;t<frm[i].mx+2;t++) {
     offset=(frm[i].x+t-2)*2+(frm[i].y+frm[i].infol[frm[i].idx].linec-1)*160;
     pokeb(DISPSEG,offset+1,peekb(DISPSEG,offset+1)%16+16*col);
   }
}

void previewsubmenu(byte i)
{
  byte t,col;

  box(i,_menuattr,_menulinefont);

  for (t=0;t<frm[i].num;t++) {
    if (frm[i].infol[t].nouse) col=_nouseattr; else col=_menuattr;
    fprint(*(frm[i].str+t),frm[i].x,frm[i].y+frm[i].infol[t].linec,
	   col,frm[i].infol[t].nouse);
    if (frm[i].sub[t] != NONE)
      p16c(frm[i].x+frm[i].mx-1,frm[i].y+frm[i].infol[t].linec,
	   _submenusign,col);
  }
}

char checknouse(byte i)
{
  return(frm[i].infol[frm[i].idx].nouse);
}

byte getsubmenuidx(byte i)
{
  return(frm[i].sub[frm[i].idx]);
}

byte gettopsck(int inkey)
{
  byte k;

  if (!altpushed()) return(NONE);

  k=findmenuhlk(0, inkey);
  if ((k==NONE) || frm[0].infol[k].nouse) return(NONE);

  return(k);
}

byte getsubmenusck(byte midx, int inkey)
{
  byte k;

  if (altpushed()) return(NONE);

  k=findmenuhlk(midx,inkey);
  if ((k==NONE) || frm[midx].infol[k].nouse) return(NONE);

  return(k);
}

int subprocess(byte i)
{
  byte k;
  int inkey, *buf,*sbuf;
  clock_t start,end;

  save_screen(i,&buf);
  previewsubmenu(i);
  drawbar(i,TRUE);

  while (TRUE) {
    if (_multiproc) (*_multiprocess)();

    if ((_previewing) && (getsubmenuidx(i) != NONE)) {
      start=clock();

      while (!kbhit()) {
	if (_multiproc) (*_multiprocess)();
	end=clock();

	if (!checknouse(i) && (labs(end-start) >= _timereact)) {
	  save_screen(getsubmenuidx(i),&sbuf);
	  previewsubmenu(getsubmenuidx(i));
	  while (!kbhit()) if (_multiproc) (*_multiprocess)();
	  restore_screen(getsubmenuidx(i),&sbuf);
	  break;
	}
      } /* end of while */
    } else if (!kbhit()) continue;

    inkey=bioskey(0);

    if((k=findsck(inkey)) != NONE) {
      restore_screen(i,&buf);
      return(_sckbuf[k].key);
    }

    /* checks the shortcut of title only */
    if ((k=gettopsck(inkey)) != NONE) {
       restore_screen(i,&buf);
       inkey=inkey;
       return(inkey);
    }

    /* checks the shortcut of submenu */
    if ((k=getsubmenusck(i,inkey)) != NONE) {
       drawbar(i,FALSE);
       frm[i].idx=k;
       drawbar(i,TRUE);
       inkey=_ENTER;
    }

    switch (inkey) {
      case _ESC:
	      restore_screen(i,&buf);
	      return(_ESC);

      case _ENTER:
	      if (checknouse(i)) break;
	      drawbar(i,TRUE);

	      if (getsubmenuidx(i) != NONE) inkey=subprocess(getsubmenuidx(i));
	      else {
		restore_screen(i,&buf);
		_menuidx=i;
		_baridx=frm[i].idx;
		return(inkey);
	      }

	      if (inkey != _ESC) {
		restore_screen(i,&buf);
		return(inkey);
	      }
	      break;

      case _UP:
	      drawbar(i,FALSE);
	      if (frm[i].idx > 0) frm[i].idx--;
	      else frm[i].idx=frm[i].num-1;
	      break;
      case _DOWN:
	      drawbar(i,FALSE);
	      if (frm[i].idx < (frm[i].num-1)) frm[i].idx++;
	      else frm[i].idx=0;
	      break;
      case _LEFT:
	      if (frm[i].prev<1) {
		restore_screen(i,&buf);
		return(_LEFT);
	      }
	      break;
      case _RIGHT:
	      if (frm[i].prev<1) {
		restore_screen(i,&buf);
		return(_RIGHT);
	      }
	      break;
    } /* end of switch */

    drawbar(i,TRUE);
  }
}

void drawbartop(char bool)
{
   byte t,l,col;
   unsigned offset;

   if (bool) {
     if (checknouse(0)) col=_nousebarcolor; else col=_barcolor;
   } else col=_menubkcolor;

   l=strlen(*(frm[0].str+frm[0].idx));
   for (t=0;t<=l;t++) {
     offset=(frm[0].infol[frm[0].idx].linec-1+t)*2+(frm[0].y-1)*160;
     pokeb(DISPSEG,offset+1,peekb(DISPSEG,offset+1)%16+16*col);
   }
}

byte findmenuhlk(char idx, int inkey)
{
  byte t,pos;

  inkey=scan2char((char)(inkey>>8));

  for (t=0; t<frm[idx].num; t++) {
    pos=posc(*(frm[idx].str+t),_schltrigger);
    if (pos==0) continue;
    if (inkey==toupper((char)*(*(frm[idx].str+t)+pos))) return(t);
  }

  return(NONE);
}

void _popuprestore()  /* internal procedure */
{
   drawbartop(FALSE);
   if (!_POPUP) return;

   movedata(_DS,(unsigned)_popupsave,DISPSEG,(frm[0].y-1)*160,160);
   free(_popupsave);
}

int quitstate(byte midx, byte bidx, int rc)
{
  _popuprestore();

  _menuidx=midx;
  _baridx=bidx;

  return(rc);           /* return the value with no modification */
}

void drawtitle()
{
  int t;
  char s[40];

  /* draws top line */
  for (t=1;t<=80;t++) p16c(t,frm[0].y,' ',_menuattr);

  /* write top menus */
  for (t=0;t<frm[0].num;t++) {
    strcat((strcpy(s," "),strcat(s,*(frm[0].str+t)))," ");
    if (frm[0].infol[t].nouse)
      fprint(s,frm[0].infol[t].linec,frm[0].y, _nouseattr, TRUE);
    else fprint(s,frm[0].infol[t].linec,frm[0].y, _menuattr, FALSE);
  }
}

int selectmenu(int ink)
{
  int inkey;
  byte k;

  if (!_callonce) initializer();

  _menuselected=TRUE;

  /* find shortcut key */
  if ((k=findsck(ink)) != NONE) {
    _menuidx=_sckbuf[k].fn;
    _baridx=_sckbuf[k].ln;
    return(_sckbuf[k].key);
  }

  if ((ink != 0) &&
      (((k=findmenuhlk(0,ink)) == NONE) || !altpushed() ||
      frm[0].infol[k].nouse)) {
      _menuselected=FALSE;
      return(ink);
  }

  if (_POPUP) {
    _popupsave=(char *)malloc(160);
    movedata(DISPSEG,(frm[0].y-1)*160,_DS,(unsigned)_popupsave,160);
    drawtitle();
  }

  drawbartop(TRUE);

  while (TRUE) {
    if (_multiproc) (*_multiprocess)();

    if (ink!=0) {
      inkey=ink;
      ink=0;
    } else if (kbhit()) inkey=bioskey(0); else continue;

    if ((k=findsck(inkey)) != NONE)
      return(quitstate(_sckbuf[k].fn, _sckbuf[k].ln, _sckbuf[k].key));

    if (((k=gettopsck(inkey)) != NONE) || ((k=getsubmenusck(0,inkey)) != NONE)) {
      drawbartop(FALSE);
      frm[0].idx=k;
      inkey=_ENTER;
    }

    switch (inkey) {
      case _ESC:
	      _menuselected=FALSE;
	      _popuprestore();
	      return(inkey);

      case _DOWN:
	      if (getsubmenuidx(0) == NONE) break;
      case _ENTER:
	      if (checknouse(0)) break;
	      if (getsubmenuidx(0) == NONE) return(quitstate(0,frm[0].idx,inkey));
              else {

		drawbartop(TRUE);
		inkey=_LEFT;  /* a sign to pass into the WHILE */

		while ((inkey==_LEFT) || (inkey==_RIGHT)) {
		  if (_multiproc) (*_multiprocess)();

		  if ((getsubmenuidx(0) != NONE) && !checknouse(0))
		    inkey=subprocess(getsubmenuidx(0));
		  else if (kbhit()) inkey=bioskey(0); else continue;

		  if ((k=findsck(inkey)) != NONE)
		    return(quitstate(_sckbuf[k].fn,_sckbuf[k].ln,_sckbuf[k].key));

		  /* checks the shortcut of title only */
		  if (((k=gettopsck(inkey)) != NONE) && !checknouse(0)) {
		    drawbartop(FALSE);
                    frm[0].idx=k;
		    drawbartop(TRUE);

		    if (getsubmenuidx(0) == NONE)
		      return(quitstate(0,frm[0].idx,inkey));

                    inkey=_LEFT;
                    continue;
                  }

		  switch (inkey) {
                    case _UP:
                    case _DOWN:inkey=_LEFT; continue;

		    case _LEFT:
		      drawbartop(FALSE);
		      if (frm[0].idx>0) frm[0].idx--;
		      else frm[0].idx=(frm[0].num-1);
		      break;

		    case _RIGHT:
		      drawbartop(FALSE);
                      if (frm[0].idx<(frm[0].num-1)) frm[0].idx++;
		      else frm[0].idx=0;
		      break;

		    case _ESC:
		       _menuselected=FALSE;
		       _popuprestore();
		       return(inkey);

		    case _ENTER:
		       if (checknouse(0)) {
			 inkey=_LEFT;
			 continue;
		       }
		       _popuprestore();
		       return(inkey);

		  } /* end of switch */
		  drawbartop(TRUE);

		} /* end of while */
	      } /* end of else */
	      break; /* end of ENTER */

      case _LEFT:
	drawbartop(FALSE);
        if (frm[0].idx>0) frm[0].idx--;
	else frm[0].idx=(frm[0].num-1);
	break;

      case _RIGHT:
	drawbartop(FALSE);
	if (frm[0].idx<(frm[0].num-1)) frm[0].idx++;
	else frm[0].idx=0;
	break;
    }

    drawbartop(TRUE);
  }
}

byte charcounter(char *str, byte len, char c)
{
  byte t,cnt=0;

  for (t=0;t<len;t++)
    if (*(str+t) == c) cnt++;

  return(cnt);
}

byte maxlen(char **str,byte num)
{
  byte t,cnt=0,idx;

  for (t=0;t<num;t++)
    if (strlen(*(str+t))>cnt) {
      cnt=strlen(*(str+t));
      idx=t;
    }

  cnt-=(charcounter(*(str+idx),cnt,_schltrigger)+
	charcounter(*(str+idx),cnt,_menucuttrigger));

  return(cnt);
}

void p16c(char x, char y, byte ch, byte cc)
{
  poke(DISPSEG,(x-1)*2+(y-1)*160, (cc << 8) | ch);
}

void shadowedcolor(unsigned in, unsigned *out )
{
  byte LC, BC;

  LC=in / 256 % 16;
  BC=in / 256 / 16;
  if (LC<9) LC=8; else LC-=8;
  if (BC<9) BC=0; else BC-=8;
  *out=((LC+BC*16) << 8) + (in % 256);
}

void shadowing(char t, char l, char b, char r)
{
  byte i;
  unsigned out, offs;

  for (i=t+1;i<=(b+1);i++) {
    if ((r*2)<160) {
      offs=(r)*2+(i-1)*160;
      shadowedcolor(peek(DISPSEG,offs),&out);
      poke(DISPSEG,offs,out);
    }
    if ((r+1)*2<160) {
      offs=(r+1)*2+(i-1)*160;
      shadowedcolor(peek(DISPSEG,offs),&out);
      poke(DISPSEG,offs,out);
    }
  }

  if (b<25)
    for (i=l+2;i<=r;i++) {
      offs=(i-1)*2+(b)*160;
      shadowedcolor(peek(DISPSEG,offs),&out);
      poke(DISPSEG,offs,out);
    }
}

void drawcutline(char t, char l, char r, byte bc, char font)
{
  char *bf="ô̹";
  char tmp;

  if (font==0) font=0; else font=3;

  p16c(l+1,t,*(bf+font),bc);
  p16c(r-1,t,*(bf+font+1),bc);
  for (tmp=l+2;tmp<=r-2;tmp++) p16c(tmp,t,*(bf+font+2),bc);
}

void box(byte id, byte bc, char font)
{
  char *bf="ڿٳɻȼ";
  char tmp,i,k;
  char t,l,b,r;

  t=frm[id].y-1;
  l=frm[id].x-3;
  b=frm[id].y+frm[id].num+frm[id].infom.menucn;
  r=frm[id].x+frm[id].mx+2;

  if (font==0) k=0; else k=6;

  for (tmp=t+1; tmp<=b-1; tmp++)
    for (i=l+2; i<=r-2; i++) p16c(i,tmp,' ',bc);

  for (tmp=t; tmp<=b; tmp++) {
    p16c(l,tmp,' ',bc);
    p16c(r,tmp,' ',bc);
  }

  for (tmp=l+2; tmp<=r-2; tmp++) {
    p16c(tmp,t,*(bf+5+k),bc);
    p16c(tmp,b,*(bf+5+k),bc);
  }

  for (tmp=t+1; tmp<=b-1; tmp++) {
    p16c(l+1,tmp,*(bf+4+k),bc);
    p16c(r-1,tmp,*(bf+4+k),bc);
  }

  p16c(l+1,t,*(bf+k),bc);
  p16c(r-1,t,*(bf+1+k),bc);
  p16c(l+1,b,*(bf+2+k),bc);
  p16c(r-1,b,*(bf+3+k),bc);

  for (tmp=0; tmp<frm[id].num; tmp++)
    if (**(frm[id].str+tmp)==_menucuttrigger)
       drawcutline(t+frm[id].infol[tmp].linec,l,r,bc,font);

  if (_mshadowing) shadowing(t,l,b,r);
}

void save_screen(byte i,int *buf)
{
  int t,lx,ly, *wbuf;

  lx=frm[i].mx+8;
  ly=frm[i].num+3+frm[i].infom.menucn;

  if ((wbuf = (int *) malloc(lx*ly*2)) == NULL) {
     printf("Not enough memory to allocate buffer\n");
     exit(1);
  }

  *buf=(unsigned)wbuf;

  for (t=0;t<ly;t++) {
    movedata(DISPSEG, (frm[i].x-4)*2+(frm[i].y-2+t)*160,_DS,
	     (unsigned)wbuf,lx*2);
    wbuf+=lx;
  }
}

void restore_screen(byte i, int *buf)
{
  int t,lx,ly, *wbuf;

  lx=frm[i].mx+8;
  ly=frm[i].num+3+frm[i].infom.menucn;

  wbuf=(int *)*buf;

  for (t=0;t<ly;t++) {
    movedata(_DS,(unsigned)wbuf,
	     DISPSEG,(frm[i].x-4)*2+(frm[i].y-2+t)*160,lx*2);
    wbuf+=lx;
  }

  free((unsigned *)(*buf));
}

void fprint(char *str, char x, char y, byte attr, char bool)
{
  /* fast 16bit writting routine */
  char hattr;
  unsigned far *v=(unsigned far *)DISPFSEG+(x-1)+(y-1)*80;

  if (bool) hattr=attr;
  else hattr=attr/16*16+_schlcolor;

  if (*str ==  _menucuttrigger) *str++;
  while (*str)
    if (*str == _schltrigger) {
      *str++;
      *v++=(hattr << 8) | *str++;
    }
    else *v++=(attr << 8) | *str++;
}

void cursor(int nf)
{
  if (nf) asm {
    mov  ah, 1
    mov  ch, 6
    mov  cl, 7
    int  10h
  } else asm {
    mov ah, 1
    mov ch, 0fh
    mov cl, 0
    int 10h
  }
}

byte poss(char *str1, char *str2)
{
  char *ptr;

  if (*str1==0 || *str2==0) return 0;

  ptr=strstr(str1,str2);
  if (ptr==NULL) return 0;
  else return(ptr-str1+1);
}

byte posc(char *str, char c)
{
  byte t=1;

  while (*str)
    if (*str++ == c) return(t);
    else t++;

  return 0;
}

void nullfunction() {} /* do nothing */

void FIRSTSET()
{
  _menuattr=_menufgcolor+_menubkcolor*16;
  _nouseattr=_nousefgcolor+_menubkcolor*16;

  /* At first, set up _multiprocess to nullfunction temporarily */
  _multiprocess=nullfunction;
  resetsck();
}

void initializer()
{
  byte t,k;

  _callonce=TRUE;

  /* correct X-coordinate of sub-frame */
  for (t=1;t<_frameidx;t++)
    for (k=0;k<frm[t].num;k++)
      frm[frm[t].sub[k]].x=frm[t].x+_submenudist;

  /* correct being out of coordinates */
  for (t=1;t<_frameidx;t++) {
    if ((frm[t].x+frm[t].mx)>78)
      frm[t].x-=(frm[t].x+frm[t].mx)-78;
    if ((frm[t].y+frm[t].num+frm[t].infom.menucn)>25)
      frm[t].y-=(frm[t].y+frm[t].num+frm[t].infom.menucn)-25;
  }

  _timereact=lroundoff(_prevreactime*18.2);
}

unsigned long lroundoff(float x)
{
  return((long)floor(x+0.5));
}

byte scan2char(byte scancode)   /* change scancode to ascii */
{
  byte t;

  for (t=0;t<26;t++)
    if (alpha_data[t]==scancode) return(t+'A');
  for (t=0;t<10;t++)
    if (number_data[t]==scancode) return(t+'0');

  return 0;
}

void setnouse(byte i, char ln, char bool)
{
  frm[i].infol[ln].nouse=bool;
}

char getnouse(byte i, char ln)
{
  return(frm[i].infol[ln].nouse);
}

char altpushed()
{
  if ((peekb(0x0040,0x0017) & 8) != 0) return(TRUE);
  else return(FALSE);
}

char getmenucn(byte fn)
{
   int t;
   char cnt=0;

   for (t=0;t<frm[fn].num;t++)
     if (**(frm[fn].str+t) == _menucuttrigger) cnt++;

   return(cnt);
}

void resetmenu()
{
  memset(frm,0,sizeof(frm));

  _frameidx=1;
  _callonce=FALSE;
  _menuidx=0;
  _baridx=0;

  FIRSTSET();
}

void addsck(byte fn, byte ln, int kval)
{
  if (_sckbufidx<MAXSHORTCUTBUF) {
    _sckbuf[_sckbufidx].key=kval;
    _sckbuf[_sckbufidx].fn=fn;
    _sckbuf[_sckbufidx].ln=ln;
    _sckbufidx++;
  }
}

byte findsck(int ink)
{
  byte t;

  for (t=0;t<_sckbufidx;t++)
    if (_sckbuf[t].key==ink) return(t);

  return(NONE);
}

void resetsck()
{
  _sckbufidx=0;
  memset(_sckbuf,0,sizeof(_sckbuf));
}

char *getstr(byte fn,byte ln)
{
  return(*(frm[fn].str+ln));
}

void setstr(byte fn, byte ln, char *str, byte idx, char bool)
{
  int t;

  if (idx > strlen(*(frm[fn].str+ln))) return;
  if (idx<1) idx=1; else idx--;
  for (t=idx;((*(*(frm[fn].str+ln)+t) != NULL) &&
             (*(str+t-idx) != NULL)); t++)
    *(*(frm[fn].str+ln)+t)=*(str+t-idx);

  if (bool)
    for (;*(*(frm[fn].str+ln)+t) != NULL; t++)
      *(*(frm[fn].str+ln)+t)=' ';
}

void multitest()
{
   static unsigned i;
   gotoxy(60,25);
   cprintf("%6u",i++);
}
